#
# Terran Land-Based Cruise Missile
#
local TMissileCruiseProjectile = import('/lua/modules/terranprojectiles.lua').TMissileCruiseProjectile
local EffectTemplate = import('/lua/modules/EffectTemplates.lua')
local SingleBeamProjectile = import('/lua/modules/defaultprojectiles.lua').SingleBeamProjectile

TIFMissileCruise03 = Class(TMissileCruiseProjectile) {

    FxTrails = EffectTemplate.TMissileExhaust01,
    FxTrailOffset = -0.85,
    
    FxAirUnitHitScale = 0.5,
    FxLandHitScale = 0.5,
    FxNoneHitScale = 0.5,
    FxPropHitScale = 0.5,
    FxProjectileHitScale = 0.5,
    FxProjectileUnderWaterHitScale = 0.5,
    FxShieldHitScale = 0.5,
    FxUnderWaterHitScale = 0.5,
    FxUnitHitScale = 0.5,
    FxWaterHitScale = 0.5,
    FxOnKilledScale = 0.5,
    
    OnCreate = function(self)
        TMissileCruiseProjectile.OnCreate(self)
        self:SetCollisionShape('Sphere', 0, 0, 0, 1.0)
        self:ForkThread(self.CruiseMissileThread)
    end,

    CruiseMissileThread = function(self)
        self:SetTurnRate(20)
        WaitSeconds(2)
        self:SetTurnRate(180)
        WaitSeconds(1)
        self:SetTurnRate(180)
    end,
    
    OnImpact = function(self, targetType, targetEntity)
        local army = self:GetArmy()
        CreateLightParticle( self, -1, army, 3, 4, 'glow_03', 'ramp_fire_01' ) 
        SingleBeamProjectile.OnImpact(self, targetType, targetEntity)
    end,
}
TypeClass = TIFMissileCruise03

